package pt.tobenamed.tese;

import javafx.css.ParsedValue;
import javafx.util.Pair;

import java.io.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


public class Main {

    public enum Repair {e, g, i, n, eg, ei, en, in, gn, gi, egi, ein, egn, gin, egin, lol}

    ;
    public static Repair repair;

    public static boolean isRepairG() {
        return Main.repair.equals(Main.Repair.g) || Main.repair.equals(Main.Repair.gn) ||
                Main.repair.equals(Main.Repair.gi) || Main.repair.equals(Main.Repair.eg)
                || Main.repair.equals(Main.Repair.egn) || Main.repair.equals(Main.Repair.gin)
                || Main.repair.equals(Main.Repair.egin) || Main.repair.equals(Main.Repair.egi);
    }


    public static void main(String[] args) {
        File file = new File(args[0]);

        List<Function> function = new ArrayList<Function>();
        List<Not> functionNot = new ArrayList<Not>();
        Map<String, Pair<String, Integer>> vertex = new HashMap<String, Pair<String, Integer>>();
        String[] filename = args[0].split("\\.");

        repair = Repair.valueOf(filename[1].substring(3));
        BufferedReader reader = null;
        try {
            reader = new BufferedReader(new FileReader(file));
            String text = null;
            String[] temp;
            while ((text = reader.readLine()) != null) {
                List<String> regulator = new ArrayList<String>();
                temp = text.split(":");

                for (int i = 0; i < temp.length; i++) {

                    while (temp[i].equals("regulator")) {
                            regulator.add(temp[i + 1]);
                        i += 2;
                    }
                    if (temp[i].equals("AND")) {
                        Function f = new Function(temp[i + 9], temp[i + 1], temp[i + 3], temp[i + 7], temp[i + 5], regulator);
                        function.add(f);
                    }

                    if (temp[i].equals("originalvertexname")) {

                        Pair<String, Integer> pair;
                        if (temp[i + 5].equals("Notgiven")) {
                            pair = new Pair<String, Integer>(temp[i + 1], -42);
                        } else {
                            pair = new Pair<String, Integer>(temp[i + 1], Integer.parseInt(temp[i + 5]));
                        }

                        vertex.put(temp[i + 3], pair);
                    }
                    if (temp[i].equals("originvertex")) {
                        functionNot.add(new Not(temp[i + 1], temp[i + 7], temp[i + 9], Boolean.parseBoolean(temp[i + 5]), temp[i + 3]));

                    }


                }


            }

        } catch (
                FileNotFoundException e
                )

        {
            e.printStackTrace();
        } catch (
                IOException e
                )

        {
            e.printStackTrace();
        }


        file = new

                File(args[1]);
        System.out.println(args[1]);

        reader = null;
        try

        {
            reader = new BufferedReader(new FileReader(file));
            String text = null;
            String[] temp;
            while ((text = reader.readLine()) != null) {
                List<String> regulator = new ArrayList<String>();
                temp = text.split(" ");
                if (temp[0].equals("v")) {
                    for (int i = 1; i < temp.length; i++) {
                        // System.out.println(temp[i].startsWith("-"));
                        if (temp[i].startsWith("-")) {

                            String s[] = temp[i].split("-");

                            for (int j = 0; j < function.size(); j++) {
                                Function f = function.get(j);
                                f.check(s[1], false);

                            }


                            if (vertex.containsKey(s[1])) {

                                if (vertex.get(s[1]).getValue() == -42) {
                                    Pair<String, Integer> p = vertex.get(s[1]);
                                    vertex.put(s[1], new Pair<String, Integer>(p.getKey(), 0));

                                } else if (vertex.get(s[1]).getValue() != 0) {
                                    System.err.print("Hard constraint moved");
                                    System.exit(-1);
                                }
                            }
                            for (int j = 0; j < functionNot.size(); j++) {
                                Not n = functionNot.get(j);
                                n.check(s[1], false, repair);

                            }

                        } else {
                            for (int j = 0; j < function.size(); j++) {
                                Function f = function.get(j);
                                //System.out.println(temp[i]);
                                f.check(temp[i], true);

                            }


                            if (vertex.containsKey(temp[i])) {

                                if (vertex.get(temp[i]).getValue() == -42) {

                                    Pair<String, Integer> p = vertex.get(temp[i]);
                                    vertex.put(temp[i], new Pair<String, Integer>(p.getKey(), 1));
                                } else if (vertex.get(temp[i]).getValue() != 1) {
                                    System.err.print("Hard constraint moved");
                                    System.exit(-1);
                                }
                            }
                            for (int j = 0; j < functionNot.size(); j++) {
                                Not n = functionNot.get(j);
                                n.check(temp[i], true, repair);
                            }


                        }
                    }
                }
            }
        } catch (
                FileNotFoundException e
                )

        {
            e.printStackTrace();
        } catch (
                IOException e
                )

        {
            e.printStackTrace();
        }

       for (
                int j = 0;
                j < function.size(); j++)

        {
            Function f = function.get(j);
            if (!f.getNorAndDest().equals("-42")) {
                if (vertex.containsKey(f.getNorAndDest())) {
                    System.out.println("functionOr(\"output_" + vertex.get(f.getNorAndDest()).getKey()+"\","+vertex.get(f.getNorAndDest()).getKey()+").");
                    for (int i = 0; i < f.regulator.size(); i++) {
                        if(vertex.containsKey(f.regulator.get(i)))
                            System.out.println(" " + vertex.get(f.regulator.get(i)));
                        else{
                            boolean b=false;
                            int k = 0;
                            for (; k < functionNot.size() ; k++) {
                                b=functionNot.get(k).check(f.regulator.get(i),repair);
                                //System.out.println("NOT"+f.regulator.get(i));
                                if(b){
                                    break;
                                }

                            }
                            if(b){
                                System.out.println("regulator(\"output_"+vertex.get(f.getNorAndDest()).getKey()+"\","+vertex.get(functionNot.get(k).dest).getKey()+").");//+functionNot.get(k).s_temp );
                            }


                        }
                    }
                } else System.err.printf("Erro?!");

            }
            if (!f.getOrAndDest().equals("-42")) {
                if (vertex.containsKey(f.getOrAndDest())) {
                    System.out.println("functionOr(\"output_" + vertex.get(f.getOrAndDest()).getKey()+"\","+vertex.get(f.getOrAndDest()).getKey()+").");
                    for (int i = 0; i < f.regulator.size(); i++) {
                        if(vertex.containsKey(f.regulator.get(i)))
                            System.out.println(" " + vertex.get(f.regulator.get(i)));
                        else{
                            boolean b=false;
                            int k = 0;
                           for (; k < functionNot.size() ; k++) {
                                b=functionNot.get(k).check(f.regulator.get(i),repair);
                                if(b){
                                    break;
                                }

                            }
                            if(b){
                                System.out.println("regulator(\"output_"+vertex.get(f.getOrAndDest()).getKey()+"\","+vertex.get(functionNot.get(k).dest).getKey()+").");//+functionNot.get(k).s_temp );
                            }


                        }

                    }
                  //  System.out.println("");
                } else System.err.printf("Erro?!");
            }
            if (!f.getAndAndDest().equals("-42")) {
                if (vertex.containsKey(f.getAndAndDest())) {
                    System.out.println("functionAnd(\"output_" + vertex.get(f.getAndAndDest()).getKey()+"\","+vertex.get(f.getAndAndDest()).getKey()+").");
                    for (int i = 0; i < f.regulator.size(); i++) {
                        if(vertex.containsKey(f.regulator.get(i)))
                            System.out.println(" " + vertex.get(f.regulator.get(i)));
                        else{
                            boolean b=false;
                            int k = 0;
                            for (; k < functionNot.size() ; k++) {
                                b=functionNot.get(k).check(f.regulator.get(i),repair);
                                if(b){
                                    break;
                                }

                            }
                            if(b){
                                System.out.println("regulator(\"output_" + vertex.get(f.getAndAndDest()).getKey()+"\","+vertex.get(functionNot.get(k).dest).getKey()+").");//+functionNot.get(k).s_temp );
                            }


                        }
                    }
                } else System.err.printf("Erro?!");
            }
            if (!f.getNandAndDest().equals("-42")) {
                if (vertex.containsKey(f.getNandAndDest())) {
                    System.out.println("functionNand(\"output_\"" + vertex.get(f.getNandAndDest()).getKey().substring(1)+","+ vertex.get(f.getNandAndDest()).getKey()+").");
                    for (int i = 0; i < f.regulator.size(); i++) {
                        if(vertex.containsKey(f.regulator.get(i))) {
                            int i1;                       }
                        else{
                            boolean b=false;
                            int k = 0;
                            for (; k < functionNot.size() ; k++) {
                                b=functionNot.get(k).check(f.regulator.get(i),repair);
                                if(b){
                                    break;
                                }

                            }
                            if(b){
                                System.out.println("regulator(\"output_"+vertex.get(f.getNandAndDest()).getKey()+"\","+vertex.get(functionNot.get(k).dest).getKey()+").");
                            }


                        }
                    }
                } else System.err.printf("Erro?!");
            }

        }
    }

}
